big fix switch-mail-host plus minor improvements
authorIan Kelling <ian@iankelling.org>
Thu, 27 Jul 2023 05:24:28 +0000 (01:24 -0400)
committerIan Kelling <ian@iankelling.org>
Thu, 27 Jul 2023 05:24:28 +0000 (01:24 -0400)
brc
mailtest-check
switch-mail-host

diff --git a/brc b/brc
index 971cb02b7de02678fc5d9ce89a77df8fc5c4924a..83721fc80fe6a20d9d0daee14de886149ed8b546 100644 (file)
--- a/brc
+++ b/brc
@@ -1433,9 +1433,12 @@ re() {
   grr -m 5 "$@"
 }
 
-hr() { # horizontal row. used to break up output
-  printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
-  echo
+# horizontal row. used to break up output
+hr() {
+  local blocks
+  # 180 is long enough.
+  blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
+  printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
 }
 # highlight
 hl() {
index 42245111248bf7e68f2151345ac373e59132c5c7..b2e02c3112e06a32c7fd0864b2f30e621190155c 100755 (executable)
@@ -257,7 +257,6 @@ EOF
             #   echo mailtest-check: cat $latest:
             #   cat $latest
             #   echo mailtest-check: end of cat
-            #   echo "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
             #fi
           fi
           rm -f $resultfile
index f7d926c39b84481b0834f4a3a72e8f85280218c5..21d988251f31dd7e88a2cc5ee13fee808faacbf2 100644 (file)
@@ -104,7 +104,7 @@ if [[ ! $HOSTNAME ]]; then
 fi
 
 uninstalled-file-die() {
-  die "uninstalled file $1. run install-my-scripts or rerun with -f"
+  die "on host=$HOSTNAME, uninstalled file $1. run install-my-scripts or rerun with -f"
 }
 
 
@@ -154,17 +154,12 @@ case $direction in
     bbk_args="-s $old_host"
     old_shell="ssh -F $HOME/.ssh/confighome root@$old_host"
     # tests ssh connection. crafted this to not need to do escape chars
-    f=/a/bin/bash_unpublished/source-state
-    if ! old_info=$($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f"); then
-      echo "$pre: error: failed ssh. retrying failed $old_shell with -v for more info:"
-      $old_shell -v hostname
-      exit 1
-    fi
-    IFS=" " read -r old_hostname MAIL_HOST HOST2 <<<"$old_info"
 
     if ! $mail_only && ! $pull_reexec ; then
       if ! $force; then
-        $old_shell switch-mail-host --check-installed
+        if ! $old_shell switch-mail-host --check-installed; then
+          die "failed: $old_shell switch-mail-host --check-installed"
+        fi
       fi
       tmpf=$(mktemp)
       m scp -F $HOME/.ssh/confighome root@$old_host:/usr/local/bin/switch-mail-host $tmpf
@@ -176,6 +171,14 @@ case $direction in
       fi
     fi
 
+    f=/a/bin/bash_unpublished/source-state
+    if ! old_info=$($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f"); then
+      echo "$pre: error: failed ssh. retrying failed $old_shell with -v for more info:"
+      $old_shell -v hostname
+      exit 1
+    fi
+    read -d '' -r old_hostname MAIL_HOST HOST2 <<<"$old_info" || (( $? == 1 ))
+
     ;;
   *)
     err invalid first argument
@@ -343,8 +346,8 @@ if (( ret )); then
 fi
 
 # new system is usable at this point
-printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s $(eval echo "{1..${COLUMNS:-60}}")"
-echo
+blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
+printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
 
 # once I accidentally accepted incoming mail on old host. I used this script to copy over that mail:
 #